<!DOCTYPE html>
<html lang="en">
<head>
    <title>Everpay API Documentation</title>
    <!-- Meta -->
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="shortcut icon" href="favicon.ico">
    <link href='https://fonts.googleapis.com/css?family=Open+Sans:300italic,400italic,600italic,700italic,800italic,400,300,600,700,800'
          rel='stylesheet' type='text/css'>
    <!-- FontAwesome JS -->
    <script defer src="assets/fontawesome/js/all.js"></script>
    <!-- Global CSS -->
    <link rel="stylesheet" href="assets/plugins/bootstrap/css/bootstrap.min.css">
    <!-- Plugins CSS -->
    <link rel="stylesheet" href="assets/plugins/prism/prism.css">
    <!-- Theme CSS -->
    <link id="theme-style" rel="stylesheet" href="assets/css/styles.css">
</head>

<body class="body-green">
<div class="page-wrapper">
    <!-- ******Header****** -->
    <header id="header" class="header">
        <div class="container">
            <div class="branding">
                <h1 class="logo">
                    <a href="index.html">
                            <span aria-hidden="true">
                                <img src="assets/images/everpay_logo.png" alt="Everpay" class="logo_everpay"/>
                            </span>
                        <span aria-hidden="true" class="icon_documents_alt icon"></span>
                    </a>
                </h1>
            </div><!--//branding-->
        </div><!--//container-->
    </header><!--//header-->
    <div class="doc-wrapper">
        <div class="container">
            <div id="doc-header" class="doc-header text-center">
                <h1 class="doc-title"><i class="icon fa fa-paper-plane"></i>&nbsp;&nbsp;Everpay Payment Processing API
                </h1>
                <div class="meta"><i class="far fa-clock"></i> Last updated: June 24th, 2020</div>
            </div><!--//doc-header-->
            <div class="doc-body row">
                <div class="doc-content col-md-9 col-12 order-1">
                    <div class="content-inner">
                        <section id="intro-section" class="doc-section">
                            <h2 class="section-title">API Reference</h2>
                            <div class="section-block">
                                <p>The <b>Everpay API</b> is organized around <a
                                        href="http://en.wikipedia.org/wiki/Representational_State_Transfer"
                                        target="_blank" rel="noopener noreferrer">REST</a>. Our API has predictable
                                    resource-oriented URLs, accepts <a href="http://www.json.org/" target="_blank"
                                                                       rel="noopener noreferrer">JSON-encoded</a>
                                    request bodies, returns <a href="http://www.json.org/" target="_blank"
                                                               rel="noopener noreferrer">JSON-encoded</a> responses, and
                                    uses standard HTTP response codes, authentication, and verbs. </p>
                            </div>
                        </section><!--//doc-section-->
                        <section id="installation-section" class="doc-section">
                            <h2 class="section-title">Integration</h2>
                            <div id="intro" class="section-block">
                                <h3 class="block-title">New Tenants</h3>
                                <p>Upon creation of a new <b>Tenant</b>, merchants will receive their <b>authentication
                                    credentials</b> (<i>username and password</i>), which will be used to invoke the API
                                    like
                                    the
                                    following:
                                <ul>
                                    <li>Header: <b>X-Everpay-ApiKey: username</b></li>
                                    <li>Header: <b>X-Everpay-ApiSecret: password</b></li>
                                    <li>Header: <b>Authorization: Basic {Base64 encoded username:password}</b></li>
                                </ul>
                                Once you have this credentials, you can go ahead with the following steps.
                                </p>
                            </div>
                            <div id="step1" class="section-block">
                                <h3 class="block-title">Account</h3>
                                <p>Any kind of Payment or Refund through our API should be done with a Customer <b>Account</b>.
                                    For that, the first time this Account needs to be created using the following
                                    minimum attributes:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
curl --location --request POST 'http://api.goeverpay.com/accounts' \
--header 'X-Everpay-ApiKey: {your_everpay_api_key}' \
--header 'X-Everpay-ApiSecret: {your_everpay_api_secret}' \
--header 'Authorization: Basic {your_encoded_credentials}' \
--header 'Content-Type: application/json' \
--data-raw '{
   "name": "John Smith",
   "firstNameLength": 4,
   "email": "test@test.com",
   "address1": "123 Street",
   "postalCode": "51800",
   "city": "San Francisco",
   "state": "CA",
   "country": "US",
   "locale": "en_US",
   "phone": "1800123123",
   "company": "Company LLC",
   "currency": "USD"
}'
                                    </code></pre>
                                </div>
                                <p>The expected result is:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
201 CREATED
                                    </code></pre>
                                </div>
                                <p>If you wish to check that the <b>Account</b> was stored, you should use the following
                                    request:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
curl --location --request GET 'http://api.goeverpay.com/accounts/{accountId}' \
--header 'X-Everpay-ApiKey: {your_everpay_api_key}' \
--header 'X-Everpay-ApiSecret: {your_everpay_api_secret}' \
--header 'Authorization: Basic {your_encoded_credentials}'
                                    </code></pre>
                                </div><!--//code-block-->
                                <p>An example response is:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
{
    "accountId": "126791bf-d626-464a-ab4c-d834ca3e12c9",
    "name": "John Smith",
    "firstNameLength": 4,
    "externalKey": "126791bf-d626-464a-ab4c-d834ca3e12c9",
    "email": "test@test.com",
    "billCycleDayLocal": 0,
    "currency": "USD",
    "parentAccountId": null,
    "isPaymentDelegatedToParent": false,
    "paymentMethodId": null,
    "referenceTime": "2020-06-24T10:45:55.000Z",
    "timeZone": "UTC",
    "address1": "123 Street",
    "address2": null,
    "postalCode": "51800",
    "company": "Company LLC",
    "city": "San Francisco",
    "state": "CA",
    "country": "US",
    "locale": "en_US",
    "phone": "1800123123",
    "notes": null,
    "isMigrated": null,
    "accountBalance": null,
    "accountCBA": null,
    "auditLogs": []
}
                                    </code></pre>
                                </div>
                            </div>
                            <div id="step2" class="section-block">
                                <h3 class="block-title">Add the Payment Method</h3>
                                <p>After creating the <b>Account</b>, is it required to assign a <b>Payment Method</b>
                                    to it.
                                    This can be done with the following request:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
curl --location --request POST 'http://api.goeverpay.com/accounts/{accountId}/paymentMethods?isDefault=true' \
--header 'X-Everpay-ApiKey: {your_everpay_api_key}' \
--header 'X-Everpay-ApiSecret: {your_everpay_api_secret}' \
--header 'Authorization: Basic {your_encoded_credentials}' \
--header 'Content-Type: application/json' \
--data-raw '{
   "accountId": "126791bf-d626-464a-ab4c-d834ca3e12c9",
   "pluginName": "killbill-bennupay",
   "pluginInfo": {
      "properties": [
         {
            "key": "ccHolderName",
            "value": "John Smith"
         },
         {
            "key": "ccNumber",
            "value": "4200000000000000"
         },
         {
            "key": "ccType",
            "value": "VISA"
         },
         {
            "key": "ccExpirationMonth",
            "value": "01"
         },
         {
            "key": "ccExpirationYear",
            "value": "25"
         },
         {
            "key": "ccVerificationValue",
            "value": "123"
         }
      ]
   }
}'
                                    </code></pre>
                                </div>
                                <p>The expected result is:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
201 CREATED
                                    </code></pre>
                                </div>
                                <p>If you wish to check that the <b>Payment Method</b> was associated to the
                                    <b>Account</b>,
                                    you should use the following request:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
curl --location --request GET 'http://api.goeverpay.com/accounts/{accountId}/paymentMethods?withPluginInfo=true' \
--header 'X-Everpay-ApiKey: {your_everpay_api_key}' \
--header 'X-Everpay-ApiSecret: {your_everpay_api_secret}' \
--header 'Authorization: Basic {your_encoded_credentials}'
                                    </code></pre>
                                </div><!--//code-block-->
                                <p>An example response is:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
[
    {
        "paymentMethodId": "e5052811-ba5d-4d49-916a-f1a416a195a1",
        "externalKey": "e5052811-ba5d-4d49-916a-f1a416a195a1",
        "accountId": "126791bf-d626-464a-ab4c-d834ca3e12c9",
        "isDefault": true,
        "pluginName": "killbill-bennupay",
        "pluginInfo": null,
        "auditLogs": []
    }
]
                                    </code></pre>
                                </div>
                            </div>
                            <div id="step3" class="section-block">
                                <h3 class="block-title">Trigger a Payment</h3>
                                <p>Once the <b>Account</b> and the <b>Payment Method</b> are defined, we can trigger a
                                    Payment with the following request:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
curl --location --request POST 'http://api.goeverpay.com/invoices/charges/{accountId}?autoCommit=true' \
--header 'X-Everpay-ApiKey: {your_everpay_api_key}' \
--header 'X-Everpay-ApiSecret: {your_everpay_api_secret}' \
--header 'Authorization: Basic {your_encoded_credentials}' \
--header 'Content-Type: application/json' \
--data-raw '[
   {
      "accountId": "126791bf-d626-464a-ab4c-d834ca3e12c9",
      "description": "Product description",
      "amount": 10,
      "currency": "USD"
   }
]'
                                    </code></pre>
                                </div>
                                <p>An example response is:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
[
    {
        "invoiceItemId": "d03bbee1-6462-47d5-8af9-19463e382449",
        "invoiceId": "21dc9632-b220-402a-8ea9-fe21c182080e",
        "linkedInvoiceItemId": null,
        "accountId": "126791bf-d626-464a-ab4c-d834ca3e12c9",
        "childAccountId": null,
        "bundleId": null,
        "subscriptionId": null,
        "productName": null,
        "planName": null,
        "phaseName": null,
        "usageName": null,
        "prettyProductName": null,
        "prettyPlanName": null,
        "prettyPhaseName": null,
        "prettyUsageName": null,
        "itemType": "EXTERNAL_CHARGE",
        "description": "Product description",
        "startDate": "2020-06-24",
        "endDate": null,
        "amount": 10.00,
        "rate": null,
        "currency": "USD",
        "quantity": null,
        "itemDetails": null,
        "catalogEffectiveDate": null,
        "childItems": null,
        "auditLogs": []
    }
]
                                    </code></pre>
                                </div>
                                <p>If you wish to check the <b>Payment</b>, you could use the following request:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
curl --location --request GET 'http://api.goeverpay.com/invoices/{invoiceId}/payments' \
--header 'X-Everpay-ApiKey: {your_everpay_api_key}' \
--header 'X-Everpay-ApiSecret: {your_everpay_api_secret}' \
--header 'Authorization: Basic {your_encoded_credentials}'
                                    </code></pre>
                                </div><!--//code-block-->
                                <p>An example response is:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
[
    {
        "targetInvoiceId": "21dc9632-b220-402a-8ea9-fe21c182080e",
        "accountId": "126791bf-d626-464a-ab4c-d834ca3e12c9",
        "paymentId": "a64652a0-0afd-4eb9-ac1d-09b8a9d2f6e9",
        "paymentNumber": "23",
        "paymentExternalKey": "a64652a0-0afd-4eb9-ac1d-09b8a9d2f6e9",
        "authAmount": 0,
        "capturedAmount": 0,
        "purchasedAmount": 10.00,
        "refundedAmount": 0,
        "creditedAmount": 0,
        "currency": "USD",
        "paymentMethodId": "e5052811-ba5d-4d49-916a-f1a416a195a1",
        "transactions": [
            {
                "transactionId": "38e19a9e-5caf-409c-90eb-72fb587fa845",
                "transactionExternalKey": "38e19a9e-5caf-409c-90eb-72fb587fa845",
                "paymentId": "a64652a0-0afd-4eb9-ac1d-09b8a9d2f6e9",
                "paymentExternalKey": "a64652a0-0afd-4eb9-ac1d-09b8a9d2f6e9",
                "transactionType": "PURCHASE",
                "amount": 10.00,
                "currency": "USD",
                "effectiveDate": "2020-06-24T10:52:14.000Z",
                "processedAmount": 10.00,
                "processedCurrency": "USD",
                "status": "SUCCESS",
                "gatewayErrorCode": "1001",
                "gatewayErrorMsg": "The transaction was completed successfully",
                "firstPaymentReferenceId": null,
                "secondPaymentReferenceId": null,
                "properties": null,
                "auditLogs": []
            }
        ],
        "paymentAttempts": null,
        "auditLogs": []
    }
]
                                    </code></pre>
                                </div>
                            </div>
                            <div id="step4" class="section-block">
                                <h3 class="block-title">Refund a Payment</h3>
                                <p>Once a <b>Payment</b> is processed, you can trigger a <b>Refund</b> with the following request:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
curl --location --request POST 'http://api.goeverpay.com/invoicePayments/{paymentId}/refunds' \
--header 'X-Everpay-ApiKey: {your_everpay_api_key}' \
--header 'X-Everpay-ApiSecret: {your_everpay_api_secret}' \
--header 'Authorization: Basic {your_encoded_credentials}' \
--header 'Content-Type: application/json' \
--data-raw '{
   "paymentId": "a64652a0-0afd-4eb9-ac1d-09b8a9d2f6e9",
   "amount": 10,
   "currency": "USD"
}'
                                    </code></pre>
                                </div>
                                <p>The expected result is:
                                </p>
                                <div class="code-block">
                                    <pre><code class="language-javascript">
201 CREATED
                                    </code></pre>
                                </div>
                            </div>
                        </section>
                    </div><!--//content-inner-->
                </div><!--//doc-content-->
                <div class="doc-sidebar col-md-3 col-12 order-0 d-none d-md-flex">
                    <div id="doc-nav" class="doc-nav">
                        <nav id="doc-menu" class="nav doc-menu flex-column sticky">
                            <a class="nav-link scrollto" href="#intro-section">API Reference</a>
                            <a class="nav-link scrollto" href="#installation-section">Integration</a>
                            <nav class="doc-sub-menu nav flex-column">
                                <a class="nav-link scrollto" href="#step1">Account</a>
                                <a class="nav-link scrollto" href="#step2">Payment Method</a>
                                <a class="nav-link scrollto" href="#step3">Payment</a>
                                <a class="nav-link scrollto" href="#step4">Refund</a>
                            </nav><!--//nav-->
                        </nav><!--//doc-menu-->
                    </div>
                </div><!--//doc-sidebar-->
            </div><!--//doc-body-->
        </div><!--//container-->
    </div><!--//doc-wrapper-->
</div><!--//page-wrapper-->

<footer id="footer" class="footer text-center">
    <div class="container">
        <small class="copyright">Everpay Inc. © 2020</small>
    </div><!--//container-->
</footer><!--//footer-->

<!-- Main Javascript -->
<script type="text/javascript" src="assets/plugins/jquery-3.4.1.min.js"></script>
<script type="text/javascript" src="assets/plugins/bootstrap/js/bootstrap.min.js"></script>
<script type="text/javascript" src="assets/plugins/prism/prism.js"></script>
<script type="text/javascript" src="assets/plugins/jquery-scrollTo/jquery.scrollTo.min.js"></script>
<script type="text/javascript" src="assets/plugins/stickyfill/dist/stickyfill.min.js"></script>
<script type="text/javascript" src="assets/js/main.js"></script>
</body>
</html> 

